<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Abandoned Cart Email Subscription Functionality
 */

namespace Amasty\AcartSubscriptionFunctionality\Api\Data;

interface RuleCouponCodeInterface
{
    /**
     * @param int $id
     *
     * @return void
     */
    public function setRecordId(int $id): void;

    /**
     * @return int
     */
    public function getRecordId(): int;

    /**
     * @return int
     */
    public function getRuleId(): int;

    /**
     * @param int $ruleId
     *
     * @return void
     */
    public function setRuleId(int $ruleId): void;

    /**
     * @return string|null
     */
    public function getTemplate(): ?string;

    /**
     * @param string|null $template
     *
     * @return void
     */
    public function setTemplate(?string $template): void;
}
