<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Abandoned Cart Email Subscription Functionality
 */

namespace Amasty\AcartSubscriptionFunctionality\Model\ResourceModel\History;

use Magento\Framework\App\ResourceConnection;
use Magento\Framework\DB\Select;
use Magento\SalesRule\Model\Coupon;

class GetCouponsByTemplate
{
    public const MAGENTO_SALES_COUPON_TABLE = 'salesrule_coupon';

    /**
     * @var ResourceConnection
     */
    private $resourceConnection;

    public function __construct(
        ResourceConnection $resourceConnection
    ) {
        $this->resourceConnection = $resourceConnection;
    }

    public function get(string $template): array
    {
        $connection = $this->resourceConnection->getConnection();
        $tableName = $this->resourceConnection->getTableName(self::MAGENTO_SALES_COUPON_TABLE);
        $select = $connection->select();
        $select->from($tableName)->reset(Select::COLUMNS)->columns(
            [Coupon::KEY_CODE]
        )->where(
            Coupon::KEY_CODE . ' LIKE (?)',
            $template
        );

        return $connection->fetchCol($select);
    }

    public function getQty(string $template): int
    {
        return count($this->get($template));
    }
}
