<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Abandoned Cart Email Subscription Functionality
 */

namespace Amasty\AcartSubscriptionFunctionality\Model\Rule;

use Amasty\AcartSubscriptionFunctionality\Api\Data\RuleCouponCodeInterface;
use Magento\Framework\Model\AbstractModel;

class RuleCouponCode extends AbstractModel implements RuleCouponCodeInterface
{
    public const RECORD_ID = 'record_id';
    public const RULE_ID = 'rule_id';
    public const TEMPLATE = 'template';

    protected function _construct()
    {
        $this->_init(ResourceModel\RuleCouponCode::class);
        $this->setIdFieldName(self::RECORD_ID);
    }

    public function getRecordId(): int
    {
        return (int)$this->_getData(self::RECORD_ID);
    }

    public function setRecordId(int $id): void
    {
        $this->setData(self::RECORD_ID, $id);
    }

    public function getRuleId(): int
    {
        return (int)$this->_getData(self::RULE_ID);
    }

    public function setRuleId(int $ruleId): void
    {
        $this->setData(self::RULE_ID, $ruleId);
    }

    public function getTemplate(): ?string
    {
        return $this->_getData(self::TEMPLATE);
    }

    public function setTemplate(?string $template): void
    {
        $this->setData(self::TEMPLATE, $template);
    }
}
