<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Abandoned Cart Email Subscription Functionality
 */

namespace Amasty\AcartSubscriptionFunctionality\Observer\Rule;

use Amasty\AcartSubscriptionFunctionality\Model\Rule\Handlers\LoadHandler;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;

class LoadSubscriptionPackageData implements ObserverInterface
{
    /**
     * @var LoadHandler
     */
    private $loadHandler;

    public function __construct(
        LoadHandler $loadHandler
    ) {
        $this->loadHandler = $loadHandler;
    }

    public function execute(Observer $observer)
    {
        if ($acartRule = $observer->getEvent()->getAcartRule()) {
            $this->loadHandler->execute($acartRule);
        }
    }
}
