<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Abandoned Cart Email Subscription Functionality
 */

namespace Amasty\AcartSubscriptionFunctionality\Ui\DataProvider\Rule\Modifier;

use Amasty\Acart\Model\Rule;
use Amasty\Acart\Model\Rule\Repository;
use Magento\Framework\Exception\NotFoundException;
use Magento\Ui\DataProvider\Modifier\ModifierInterface;

class Template implements ModifierInterface
{
    /**
     * @var Repository
     */
    private $repository;

    public function __construct(Repository $repository)
    {
        $this->repository = $repository;
    }

    public function modifyData(array $data): array
    {
        if (empty($data[Rule::RULE_ID])) {
            return $data;
        }
        try {
            $rule = $this->repository->get((int)$data[Rule::RULE_ID]);
        } catch (NotFoundException $exception) {
            return $data;
        }
        if ($rule->getExtensionAttributes()->getRuleCouponCode()) {
            $data['template'] = $rule->getExtensionAttributes()->getRuleCouponCode()->getTemplate();
        }

        return $data;
    }

    public function modifyMeta(array $meta): array
    {
        return $meta;
    }
}
